diff --git a/.gitignore b/.gitignore
index ced6746aa..1a111760f 100644
--- a/.gitignore
+++ b/.gitignore
@@ -1,3 +1,5 @@
+.dbeaver
+.project
 *.log
 *.bak
 /node_modules/*
diff --git a/admin/jest.config.js b/admin/jest.config.js
index b7226bd8f..9b9842bad 100644
--- a/admin/jest.config.js
+++ b/admin/jest.config.js
@@ -22,7 +22,7 @@ module.exports = {
     '^.+\\.(js|jsx)?$': 'babel-jest',
     '<rootDir>/node_modules/vee-validate/dist/rules': 'babel-jest',
   },
-  setupFiles: ['<rootDir>/test/testSetup.js'],
+  setupFiles: ['<rootDir>/test/testSetup.js', 'jest-canvas-mock'],
   testMatch: ['**/?(*.)+(spec|test).js?(x)'],
   // snapshotSerializers: ['jest-serializer-vue'],
   transformIgnorePatterns: ['<rootDir>/node_modules/(?!vee-validate/dist/rules)'],
diff --git a/admin/src/components/ChangeUserRoleFormular.spec.js b/admin/src/components/ChangeUserRoleFormular.spec.js
new file mode 100644
index 000000000..8bcd4d8e5
--- /dev/null
+++ b/admin/src/components/ChangeUserRoleFormular.spec.js
@@ -0,0 +1,254 @@
+import { mount } from '@vue/test-utils'
+import ChangeUserRoleFormular from './ChangeUserRoleFormular.vue'
+import { setUserRole } from '../graphql/setUserRole'
+import { toastSuccessSpy, toastErrorSpy } from '../../test/testSetup'
+
+const localVue = global.localVue
+
+const apolloMutateMock = jest.fn().mockResolvedValue({
+  data: {
+    setUserRole: null,
+  },
+})
+
+const mocks = {
+  $t: jest.fn((t) => t),
+  $apollo: {
+    mutate: apolloMutateMock,
+  },
+  $store: {
+    state: {
+      moderator: {
+        id: 0,
+        name: 'test moderator',
+      },
+    },
+  },
+}
+
+let propsData
+let wrapper
+
+describe('ChangeUserRoleFormular', () => {
+  const Wrapper = () => {
+    return mount(ChangeUserRoleFormular, { localVue, mocks, propsData })
+  }
+
+  describe('mount', () => {
+    beforeEach(() => {
+      jest.clearAllMocks()
+    })
+
+    describe('DOM has', () => {
+      beforeEach(() => {
+        propsData = {
+          item: {
+            userId: 1,
+            isAdmin: null,
+          },
+        }
+        wrapper = Wrapper()
+      })
+
+      it('has a DIV element with the class.delete-user-formular', () => {
+        expect(wrapper.find('.change-user-role-formular').exists()).toBe(true)
+      })
+    })
+
+    describe('change own role', () => {
+      beforeEach(() => {
+        propsData = {
+          item: {
+            userId: 0,
+            isAdmin: null,
+          },
+        }
+        wrapper = Wrapper()
+      })
+
+      it('has the text that you cannot change own role', () => {
+        expect(wrapper.text()).toContain('userRole.notChangeYourSelf')
+      })
+
+      it('has role select disabled', () => {
+        expect(wrapper.find('select[disabled="disabled"]').exists()).toBe(true)
+      })
+    })
+
+    describe('change others role', () => {
+      let rolesToSelect
+
+      describe('general', () => {
+        beforeEach(() => {
+          propsData = {
+            item: {
+              userId: 1,
+              isAdmin: null,
+            },
+          }
+          wrapper = Wrapper()
+          rolesToSelect = wrapper.find('select.role-select').findAll('option')
+        })
+
+        it('has no text that you cannot change own role', () => {
+          expect(wrapper.text()).not.toContain('userRole.notChangeYourSelf')
+        })
+
+        it('has the select label', () => {
+          expect(wrapper.text()).toContain('userRole.selectLabel')
+        })
+
+        it('has a select', () => {
+          expect(wrapper.find('select.role-select').exists()).toBe(true)
+        })
+
+        it('has role select enabled', () => {
+          expect(wrapper.find('select.role-select[disabled="disabled"]').exists()).toBe(false)
+        })
+
+        describe('on API error', () => {
+          beforeEach(() => {
+            apolloMutateMock.mockRejectedValue({ message: 'Oh no!' })
+            rolesToSelect.at(1).setSelected()
+          })
+
+          it('toasts an error message', () => {
+            expect(toastErrorSpy).toBeCalledWith('Oh no!')
+          })
+        })
+      })
+
+      describe('user is usual user', () => {
+        beforeEach(() => {
+          apolloMutateMock.mockResolvedValue({
+            data: {
+              setUserRole: new Date(),
+            },
+          })
+          propsData = {
+            item: {
+              userId: 1,
+              isAdmin: null,
+            },
+          }
+          wrapper = Wrapper()
+          rolesToSelect = wrapper.find('select.role-select').findAll('option')
+        })
+
+        it('has selected option set to "usual user"', () => {
+          expect(wrapper.find('select.role-select').element.value).toBe('user')
+        })
+
+        describe('change select to', () => {
+          describe('same role', () => {
+            it('does not call the API', () => {
+              rolesToSelect.at(0).setSelected()
+              expect(apolloMutateMock).not.toHaveBeenCalled()
+            })
+          })
+
+          describe('new role', () => {
+            beforeEach(() => {
+              rolesToSelect.at(1).setSelected()
+            })
+
+            it('calls the API', () => {
+              expect(apolloMutateMock).toBeCalledWith(
+                expect.objectContaining({
+                  mutation: setUserRole,
+                  variables: {
+                    userId: 1,
+                    isAdmin: true,
+                  },
+                }),
+              )
+            })
+
+            it('emits "updateIsAdmin"', () => {
+              expect(wrapper.emitted('updateIsAdmin')).toEqual(
+                expect.arrayContaining([
+                  expect.arrayContaining([
+                    {
+                      userId: 1,
+                      isAdmin: expect.any(Date),
+                    },
+                  ]),
+                ]),
+              )
+            })
+
+            it('toasts success message', () => {
+              expect(toastSuccessSpy).toBeCalledWith('userRole.successfullyChangedTo')
+            })
+          })
+        })
+      })
+
+      describe('user is admin', () => {
+        beforeEach(() => {
+          apolloMutateMock.mockResolvedValue({
+            data: {
+              setUserRole: null,
+            },
+          })
+          propsData = {
+            item: {
+              userId: 1,
+              isAdmin: new Date(),
+            },
+          }
+          wrapper = Wrapper()
+          rolesToSelect = wrapper.find('select.role-select').findAll('option')
+        })
+
+        it('has selected option set to "admin"', () => {
+          expect(wrapper.find('select.role-select').element.value).toBe('admin')
+        })
+
+        describe('change select to', () => {
+          describe('same role', () => {
+            it('does not call the API', () => {
+              rolesToSelect.at(1).setSelected()
+              expect(apolloMutateMock).not.toHaveBeenCalled()
+            })
+          })
+
+          describe('new role', () => {
+            beforeEach(() => {
+              rolesToSelect.at(0).setSelected()
+            })
+
+            it('calls the API', () => {
+              expect(apolloMutateMock).toBeCalledWith(
+                expect.objectContaining({
+                  mutation: setUserRole,
+                  variables: {
+                    userId: 1,
+                    isAdmin: false,
+                  },
+                }),
+              )
+            })
+
+            it('emits "updateIsAdmin"', () => {
+              expect(wrapper.emitted('updateIsAdmin')).toEqual(
+                expect.arrayContaining([
+                  expect.arrayContaining([
+                    {
+                      userId: 1,
+                      isAdmin: null,
+                    },
+                  ]),
+                ]),
+              )
+            })
+
+            it('toasts success message', () => {
+              expect(toastSuccessSpy).toBeCalledWith('userRole.successfullyChangedTo')
+            })
+          })
+        })
+      })
+    })
+  })
+})
diff --git a/admin/src/components/ChangeUserRoleFormular.vue b/admin/src/components/ChangeUserRoleFormular.vue
new file mode 100644
index 000000000..1217ce7f0
--- /dev/null
+++ b/admin/src/components/ChangeUserRoleFormular.vue
@@ -0,0 +1,89 @@
+<template>
+  <div class="change-user-role-formular">
+    <div class="shadow p-3 mb-5 bg-white rounded">
+      <div v-if="item.userId === $store.state.moderator.id" class="m-3 mb-4">
+        {{ $t('userRole.notChangeYourSelf') }}
+      </div>
+      <div class="m-3">
+        <label for="role" class="mr-3">{{ $t('userRole.selectLabel') }}</label>
+        <b-form-select
+          class="role-select"
+          v-model="roleSelected"
+          :options="roles"
+          :disabled="item.userId === $store.state.moderator.id"
+        />
+      </div>
+    </div>
+  </div>
+</template>
+
+<script>
+import { setUserRole } from '../graphql/setUserRole'
+
+const rolesValues = {
+  admin: 'admin',
+  user: 'user',
+}
+
+export default {
+  name: 'ChangeUserRoleFormular',
+  props: {
+    item: {
+      type: Object,
+      required: true,
+    },
+  },
+  data() {
+    return {
+      roleSelected: this.item.isAdmin ? rolesValues.admin : rolesValues.user,
+      roles: [
+        { value: rolesValues.user, text: this.$t('userRole.selectRoles.user') },
+        { value: rolesValues.admin, text: this.$t('userRole.selectRoles.admin') },
+      ],
+    }
+  },
+  watch: {
+    roleSelected(newRole, oldRole) {
+      if (newRole !== oldRole) {
+        this.setUserRole(newRole, oldRole)
+      }
+    },
+  },
+  methods: {
+    setUserRole(newRole, oldRole) {
+      this.$apollo
+        .mutate({
+          mutation: setUserRole,
+          variables: {
+            userId: this.item.userId,
+            isAdmin: newRole === rolesValues.admin,
+          },
+        })
+        .then((result) => {
+          this.$emit('updateIsAdmin', {
+            userId: this.item.userId,
+            isAdmin: result.data.setUserRole,
+          })
+          this.toastSuccess(
+            this.$t('userRole.successfullyChangedTo', {
+              role:
+                result.data.setUserRole !== null
+                  ? this.$t('userRole.selectRoles.admin')
+                  : this.$t('userRole.selectRoles.user'),
+            }),
+          )
+        })
+        .catch((error) => {
+          this.roleSelected = oldRole
+          this.toastError(error.message)
+        })
+    },
+  },
+}
+</script>
+
+<style>
+.role-select {
+  width: 300pt;
+}
+</style>
diff --git a/admin/src/components/ContributionLink.spec.js b/admin/src/components/ContributionLink.spec.js
new file mode 100644
index 000000000..f1b9cfb97
--- /dev/null
+++ b/admin/src/components/ContributionLink.spec.js
@@ -0,0 +1,49 @@
+import { mount } from '@vue/test-utils'
+import ContributionLink from './ContributionLink.vue'
+
+const localVue = global.localVue
+
+const mocks = {
+  $t: jest.fn((t) => t),
+}
+
+const propsData = {
+  items: [
+    {
+      id: 1,
+      name: 'Meditation',
+      memo: 'Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut l',
+      amount: '200',
+      validFrom: '2022-04-01',
+      validTo: '2022-08-01',
+      cycle: 'täglich',
+      maxPerCycle: '3',
+      maxAmountPerMonth: 0,
+      link: 'https://localhost/redeem/CL-1a2345678',
+    },
+  ],
+  count: 1,
+}
+
+describe('ContributionLink', () => {
+  let wrapper
+
+  const Wrapper = () => {
+    return mount(ContributionLink, { localVue, mocks, propsData })
+  }
+
+  describe('mount', () => {
+    beforeEach(() => {
+      wrapper = Wrapper()
+    })
+
+    it('renders the Div Element ".contribution-link"', () => {
+      expect(wrapper.find('div.contribution-link').exists()).toBe(true)
+    })
+
+    it('emits toggle::collapse new Contribution', async () => {
+      wrapper.vm.editContributionLinkData()
+      expect(wrapper.vm.$root.$emit('bv::toggle::collapse', 'newContribution')).toBeTruthy()
+    })
+  })
+})
diff --git a/admin/src/components/ContributionLink.vue b/admin/src/components/ContributionLink.vue
new file mode 100644
index 000000000..893e202f4
--- /dev/null
+++ b/admin/src/components/ContributionLink.vue
@@ -0,0 +1,66 @@
+<template>
+  <div class="contribution-link">
+    <b-card
+      border-variant="success"
+      :header="$t('contributionLink.contributionLinks')"
+      header-bg-variant="success"
+      header-text-variant="white"
+      header-class="text-center"
+      class="mt-5"
+    >
+      <b-button v-b-toggle.newContribution class="my-3 d-flex justify-content-left">
+        {{ $t('math.plus') }} {{ $t('contributionLink.newContributionLink') }}
+      </b-button>
+
+      <b-collapse v-model="visible" id="newContribution" class="mt-2">
+        <b-card>
+          <p class="h2 ml-5">{{ $t('contributionLink.contributionLinks') }}</p>
+          <contribution-link-form :contributionLinkData="contributionLinkData" />
+        </b-card>
+      </b-collapse>
+
+      <b-card-text>
+        <contribution-link-list
+          v-if="count > 0"
+          :items="items"
+          @editContributionLinkData="editContributionLinkData"
+        />
+        <div v-else>{{ $t('contributionLink.noContributionLinks') }}</div>
+      </b-card-text>
+    </b-card>
+  </div>
+</template>
+<script>
+import ContributionLinkForm from './ContributionLinkForm.vue'
+import ContributionLinkList from './ContributionLinkList.vue'
+
+export default {
+  name: 'ContributionLink',
+  components: {
+    ContributionLinkForm,
+    ContributionLinkList,
+  },
+  props: {
+    items: {
+      type: Array,
+      required: true,
+    },
+    count: {
+      type: Number,
+      required: true,
+    },
+  },
+  data: function () {
+    return {
+      visible: false,
+      contributionLinkData: {},
+    }
+  },
+  methods: {
+    editContributionLinkData(data) {
+      if (!this.visible) this.$root.$emit('bv::toggle::collapse', 'newContribution')
+      this.contributionLinkData = data
+    },
+  },
+}
+</script>
diff --git a/admin/src/components/ContributionLinkForm.spec.js b/admin/src/components/ContributionLinkForm.spec.js
new file mode 100644
index 000000000..9c7c33c52
--- /dev/null
+++ b/admin/src/components/ContributionLinkForm.spec.js
@@ -0,0 +1,102 @@
+import { mount } from '@vue/test-utils'
+import ContributionLinkForm from './ContributionLinkForm.vue'
+
+const localVue = global.localVue
+
+global.alert = jest.fn()
+
+const propsData = {
+  contributionLinkData: {},
+}
+
+const mocks = {
+  $t: jest.fn((t) => t),
+}
+
+// const mockAPIcall = jest.fn()
+
+describe('ContributionLinkForm', () => {
+  let wrapper
+
+  const Wrapper = () => {
+    return mount(ContributionLinkForm, { localVue, mocks, propsData })
+  }
+
+  describe('mount', () => {
+    beforeEach(() => {
+      wrapper = Wrapper()
+    })
+
+    it('renders the Div Element ".contribution-link-form"', () => {
+      expect(wrapper.find('div.contribution-link-form').exists()).toBe(true)
+    })
+
+    describe('call onReset', () => {
+      it('form has the set data', () => {
+        beforeEach(() => {
+          wrapper.setData({
+            form: {
+              name: 'name',
+              memo: 'memo',
+              amount: 100,
+              validFrom: 'validFrom',
+              validTo: 'validTo',
+              cycle: 'ONCE',
+              maxPerCycle: 1,
+              maxAmountPerMonth: 100,
+            },
+          })
+          wrapper.vm.onReset()
+        })
+        expect(wrapper.vm.form).toEqual({
+          amount: null,
+          cycle: 'ONCE',
+          validTo: null,
+          maxAmountPerMonth: '0',
+          memo: null,
+          name: null,
+          maxPerCycle: 1,
+          validFrom: null,
+        })
+      })
+    })
+
+    describe('call onSubmit', () => {
+      it('response with the contribution link url', () => {
+        wrapper.vm.onSubmit()
+      })
+    })
+
+    // describe('successfull submit', () => {
+    //   beforeEach(async () => {
+    //     mockAPIcall.mockResolvedValue({
+    //       data: {
+    //         createContributionLink: {
+    //           link: 'https://localhost/redeem/CL-1a2345678',
+    //         },
+    //       },
+    //     })
+    //     await wrapper.find('input.test-validFrom').setValue('2022-6-18')
+    //     await wrapper.find('input.test-validTo').setValue('2022-7-18')
+    //     await wrapper.find('input.test-name').setValue('test name')
+    //     await wrapper.find('input.test-memo').setValue('test memo')
+    //     await wrapper.find('input.test-amount').setValue('100')
+    //     await wrapper.find('form').trigger('submit')
+    //   })
+
+    //   it('calls the API', () => {
+    //     expect(mockAPIcall).toHaveBeenCalledWith(
+    //       expect.objectContaining({
+    //         variables: {
+    //           link: 'https://localhost/redeem/CL-1a2345678',
+    //         },
+    //       }),
+    //     )
+    //   })
+
+    //   it('displays the new username', () => {
+    //     expect(wrapper.find('div.display-username').text()).toEqual('@username')
+    //   })
+    // })
+  })
+})
diff --git a/admin/src/components/ContributionLinkForm.vue b/admin/src/components/ContributionLinkForm.vue
new file mode 100644
index 000000000..a159d33d3
--- /dev/null
+++ b/admin/src/components/ContributionLinkForm.vue
@@ -0,0 +1,218 @@
+<template>
+  <div class="contribution-link-form">
+    <div v-if="updateData" class="text-light bg-info p-3">
+      {{ updateData }}
+    </div>
+    <b-form class="m-5" @submit.prevent="onSubmit" ref="contributionLinkForm">
+      <!-- Date -->
+      <b-row>
+        <b-col>
+          <b-form-group :label="$t('contributionLink.validFrom')">
+            <b-form-datepicker
+              v-model="form.validFrom"
+              size="lg"
+              :min="min"
+              class="mb-4 test-validFrom"
+              reset-value=""
+              :label-no-date-selected="$t('contributionLink.noDateSelected')"
+              required
+            ></b-form-datepicker>
+          </b-form-group>
+        </b-col>
+        <b-col>
+          <b-form-group :label="$t('contributionLink.validTo')">
+            <b-form-datepicker
+              v-model="form.validTo"
+              size="lg"
+              :min="form.validFrom ? form.validFrom : min"
+              class="mb-4 test-validTo"
+              reset-value=""
+              :label-no-date-selected="$t('contributionLink.noDateSelected')"
+              required
+            ></b-form-datepicker>
+          </b-form-group>
+        </b-col>
+      </b-row>
+
+      <!-- Name -->
+      <b-form-group :label="$t('contributionLink.name')">
+        <b-form-input
+          v-model="form.name"
+          size="lg"
+          type="text"
+          placeholder="Name"
+          required
+          maxlength="100"
+          class="test-name"
+        ></b-form-input>
+      </b-form-group>
+      <!-- Desc -->
+      <b-form-group :label="$t('contributionLink.memo')">
+        <b-form-textarea
+          v-model="form.memo"
+          size="lg"
+          :placeholder="$t('contributionLink.memo')"
+          required
+          maxlength="255"
+          class="test-memo"
+        ></b-form-textarea>
+      </b-form-group>
+      <!-- Amount -->
+      <b-form-group :label="$t('contributionLink.amount')">
+        <b-form-input
+          v-model="form.amount"
+          size="lg"
+          type="number"
+          placeholder="0"
+          required
+          class="test-amount"
+        ></b-form-input>
+      </b-form-group>
+      <b-collapse id="collapse-2">
+        <b-jumbotron>
+          <b-row class="mb-4">
+            <b-col>
+              <!-- Cycle -->
+              <label for="cycle">{{ $t('contributionLink.cycle') }}</label>
+              <b-form-select
+                v-model="form.cycle"
+                :options="cycle"
+                :disabled="disabled"
+                class="mb-3"
+                size="lg"
+              ></b-form-select>
+            </b-col>
+            <b-col>
+              <!-- maxPerCycle -->
+              <label for="maxPerCycle">{{ $t('contributionLink.maxPerCycle') }}</label>
+              <b-form-select
+                v-model="form.maxPerCycle"
+                :options="maxPerCycle"
+                :disabled="disabled"
+                class="mb-3"
+                size="lg"
+              ></b-form-select>
+            </b-col>
+          </b-row>
+
+          <!-- Max amount -->
+          <b-form-group :label="$t('contributionLink.maximumAmount')">
+            <b-form-input
+              v-model="form.maxAmountPerMonth"
+              size="lg"
+              :disabled="disabled"
+              type="number"
+              placeholder="0"
+            ></b-form-input>
+          </b-form-group>
+        </b-jumbotron>
+      </b-collapse>
+      <div class="mt-6">
+        <b-button type="submit" variant="primary">{{ $t('contributionLink.create') }}</b-button>
+        <b-button type="reset" variant="danger" @click.prevent="onReset">
+          {{ $t('contributionLink.clear') }}
+        </b-button>
+      </div>
+    </b-form>
+  </div>
+</template>
+<script>
+import { createContributionLink } from '@/graphql/createContributionLink.js'
+export default {
+  name: 'ContributionLinkForm',
+  props: {
+    contributionLinkData: {
+      type: Object,
+      default() {
+        return {}
+      },
+    },
+  },
+  data() {
+    return {
+      form: {
+        name: null,
+        memo: null,
+        amount: null,
+        validFrom: null,
+        validTo: null,
+        cycle: 'ONCE',
+        maxPerCycle: 1,
+        maxAmountPerMonth: '0',
+      },
+      min: new Date(),
+      cycle: [
+        { value: 'ONCE', text: this.$t('contributionLink.options.cycle.once') },
+        { value: 'hourly', text: this.$t('contributionLink.options.cycle.hourly') },
+        { value: 'daily', text: this.$t('contributionLink.options.cycle.daily') },
+        { value: 'weekly', text: this.$t('contributionLink.options.cycle.weekly') },
+        { value: 'monthly', text: this.$t('contributionLink.options.cycle.monthly') },
+        { value: 'yearly', text: this.$t('contributionLink.options.cycle.yearly') },
+      ],
+      maxPerCycle: [
+        { value: '1', text: '1 x' },
+        { value: '2', text: '2 x' },
+        { value: '3', text: '3 x' },
+        { value: '4', text: '4 x' },
+        { value: '5', text: '5 x' },
+      ],
+    }
+  },
+  methods: {
+    onSubmit() {
+      if (this.form.validFrom === null)
+        return this.toastError(this.$t('contributionLink.noStartDate'))
+      if (this.form.validTo === null) return this.toastError(this.$t('contributionLink.noEndDate'))
+      // alert(JSON.stringify(this.form))
+      this.$apollo
+        .mutate({
+          mutation: createContributionLink,
+          variables: {
+            validFrom: this.form.validFrom,
+            validTo: this.form.validTo,
+            name: this.form.name,
+            amount: this.form.amount,
+            memo: this.form.memo,
+            cycle: this.form.cycle,
+            maxPerCycle: this.form.maxPerCycle,
+            maxAmountPerMonth: this.form.maxAmountPerMonth,
+          },
+        })
+        .then((result) => {
+          this.link = result.data.createContributionLink.link
+          this.toastSuccess(this.link)
+          this.onReset()
+        })
+        .catch((error) => {
+          this.toastError(error.message)
+        })
+    },
+    onReset() {
+      this.$refs.contributionLinkForm.reset()
+      this.form.validFrom = null
+      this.form.validTo = null
+    },
+  },
+  computed: {
+    updateData() {
+      return this.contributionLinkData
+    },
+    disabled() {
+      if (this.form.cycle === 'ONCE') return true
+      return false
+    },
+  },
+  watch: {
+    contributionLinkData() {
+      this.form.name = this.contributionLinkData.name
+      this.form.memo = this.contributionLinkData.memo
+      this.form.amount = this.contributionLinkData.amount
+      this.form.validFrom = this.contributionLinkData.validFrom
+      this.form.validTo = this.contributionLinkData.validTo
+      this.form.cycle = this.contributionLinkData.cycle
+      this.form.maxPerCycle = this.contributionLinkData.maxPerCycle
+      this.form.maxAmountPerMonth = this.contributionLinkData.maxAmountPerMonth
+    },
+  },
+}
+</script>
diff --git a/admin/src/components/ContributionLinkList.spec.js b/admin/src/components/ContributionLinkList.spec.js
new file mode 100644
index 000000000..0b9d131bd
--- /dev/null
+++ b/admin/src/components/ContributionLinkList.spec.js
@@ -0,0 +1,147 @@
+import { mount } from '@vue/test-utils'
+import ContributionLinkList from './ContributionLinkList.vue'
+import { toastSuccessSpy, toastErrorSpy } from '../../test/testSetup'
+// import { deleteContributionLink } from '../graphql/deleteContributionLink'
+
+const localVue = global.localVue
+
+const mockAPIcall = jest.fn()
+
+const mocks = {
+  $t: jest.fn((t) => t),
+  $apollo: {
+    mutate: mockAPIcall,
+  },
+}
+
+const propsData = {
+  items: [
+    {
+      id: 1,
+      name: 'Meditation',
+      memo: 'Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut l',
+      amount: '200',
+      validFrom: '2022-04-01',
+      validTo: '2022-08-01',
+      cycle: 'täglich',
+      maxPerCycle: '3',
+      maxAmountPerMonth: 0,
+      link: 'https://localhost/redeem/CL-1a2345678',
+    },
+  ],
+}
+
+describe('ContributionLinkList', () => {
+  let wrapper
+
+  const Wrapper = () => {
+    return mount(ContributionLinkList, { localVue, mocks, propsData })
+  }
+
+  describe('mount', () => {
+    beforeEach(() => {
+      wrapper = Wrapper()
+    })
+
+    it('renders the Div Element ".contribution-link-list"', () => {
+      expect(wrapper.find('div.contribution-link-list').exists()).toBe(true)
+    })
+
+    it('renders table with contribution link', () => {
+      expect(wrapper.findAll('table').at(0).findAll('tbody > tr').at(0).text()).toContain(
+        'Meditation',
+      )
+    })
+
+    describe('edit contribution link', () => {
+      beforeEach(() => {
+        wrapper.vm.editContributionLink()
+      })
+
+      it('emits editContributionLinkData', async () => {
+        expect(wrapper.vm.$emit('editContributionLinkData')).toBeTruthy()
+      })
+    })
+
+    describe('delete contribution link', () => {
+      let spy
+
+      beforeEach(async () => {
+        jest.clearAllMocks()
+        wrapper.vm.deleteContributionLink()
+      })
+
+      describe('with success', () => {
+        beforeEach(async () => {
+          spy = jest.spyOn(wrapper.vm.$bvModal, 'msgBoxConfirm')
+          spy.mockImplementation(() => Promise.resolve('some value'))
+          mockAPIcall.mockResolvedValue()
+          await wrapper.find('.test-delete-link').trigger('click')
+        })
+
+        it('opens the modal ', () => {
+          expect(spy).toBeCalled()
+        })
+
+        it.skip('calls the API', () => {
+          // expect(mockAPIcall).toBeCalledWith(
+          //   expect.objectContaining({
+          //     mutation: deleteContributionLink,
+          //     variables: {
+          //       id: 1,
+          //     },
+          //   }),
+          // )
+        })
+
+        it('toasts a success message', () => {
+          expect(toastSuccessSpy).toBeCalledWith('TODO: request message deleted ')
+        })
+      })
+
+      describe('with error', () => {
+        beforeEach(async () => {
+          spy = jest.spyOn(wrapper.vm.$bvModal, 'msgBoxConfirm')
+          spy.mockImplementation(() => Promise.resolve('some value'))
+          mockAPIcall.mockRejectedValue({ message: 'Something went wrong :(' })
+          await wrapper.find('.test-delete-link').trigger('click')
+        })
+
+        it('toasts an error message', () => {
+          expect(toastErrorSpy).toBeCalledWith('Something went wrong :(')
+        })
+      })
+
+      describe('cancel delete', () => {
+        beforeEach(async () => {
+          spy = jest.spyOn(wrapper.vm.$bvModal, 'msgBoxConfirm')
+          spy.mockImplementation(() => Promise.resolve(false))
+          mockAPIcall.mockResolvedValue()
+          await wrapper.find('.test-delete-link').trigger('click')
+        })
+
+        it('does not call the API', () => {
+          expect(mockAPIcall).not.toBeCalled()
+        })
+      })
+    })
+
+    describe('onClick showButton', () => {
+      it('modelData contains contribution link', () => {
+        wrapper.find('button.test-show').trigger('click')
+        expect(wrapper.vm.modalData).toEqual({
+          amount: '200',
+          cycle: 'täglich',
+          id: 1,
+          link: 'https://localhost/redeem/CL-1a2345678',
+          maxAmountPerMonth: 0,
+          maxPerCycle: '3',
+          memo: 'Lorem ipsum dolor sit amet, consetetur sadipscing elitr, sed diam nonumy eirmod tempor invidunt ut l',
+          name: 'Meditation',
+          validFrom: '2022-04-01',
+          validTo: '2022-08-01',
+        })
+      })
+    })
+  })
+})
